<?php

namespace NetPayment;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'RequestMoney' => '\\NetPayment\\StructType\\RequestMoney',
            'RequestMoneyResponse' => '\\NetPayment\\StructType\\RequestMoneyResponse',
            'SendMoney' => '\\NetPayment\\StructType\\SendMoney',
            'SendMoneyResponse' => '\\NetPayment\\StructType\\SendMoneyResponse',
            'SendMoneyManual' => '\\NetPayment\\StructType\\SendMoneyManual',
            'SendMoneyManualResponse' => '\\NetPayment\\StructType\\SendMoneyManualResponse',
            'CheckRequestMoneyStatus' => '\\NetPayment\\StructType\\CheckRequestMoneyStatus',
            'CheckRequestMoneyStatusResponse' => '\\NetPayment\\StructType\\CheckRequestMoneyStatusResponse',
            'SendSMS' => '\\NetPayment\\StructType\\SendSMS',
            'SendSMSResponse' => '\\NetPayment\\StructType\\SendSMSResponse',
            'GetRequestStatus' => '\\NetPayment\\StructType\\GetRequestStatus',
            'GetRequestStatusResponse' => '\\NetPayment\\StructType\\GetRequestStatusResponse',
            'GeneralResponse' => '\\NetPayment\\StructType\\GeneralResponse',
        );
    }
}
