<?php

namespace NetPayment\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RequestMoney StructType
 * @subpackage Structs
 */
class RequestMoney extends AbstractStructBase
{
    /**
     * The _Billto
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $_Billto;
    /**
     * The _Billamount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $_Billamount;
    /**
     * The _MobileNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $_MobileNumber;
    /**
     * The _BillNarration
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $_BillNarration;
    /**
     * The _Message
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $_Message;
    /**
     * The _CustomerReference
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $_CustomerReference;
    /**
     * The _Reference1
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $_Reference1;
    /**
     * The _Reference2
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $_Reference2;
    /**
     * The _newtorkID
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $_newtorkID;
    /**
     * The _Username
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $_Username;
    /**
     * The _Password
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $_Password;
    /**
     * Constructor method for RequestMoney
     * @uses RequestMoney::set_Billto()
     * @uses RequestMoney::set_Billamount()
     * @uses RequestMoney::set_MobileNumber()
     * @uses RequestMoney::set_BillNarration()
     * @uses RequestMoney::set_Message()
     * @uses RequestMoney::set_CustomerReference()
     * @uses RequestMoney::set_Reference1()
     * @uses RequestMoney::set_Reference2()
     * @uses RequestMoney::set_newtorkID()
     * @uses RequestMoney::set_Username()
     * @uses RequestMoney::set_Password()
     * @param string $_Billto
     * @param float $_Billamount
     * @param string $_MobileNumber
     * @param string $_BillNarration
     * @param string $_Message
     * @param string $_CustomerReference
     * @param string $_Reference1
     * @param string $_Reference2
     * @param int $_newtorkID
     * @param string $_Username
     * @param string $_Password
     */
    public function __construct($_Billto = null, $_Billamount = null, $_MobileNumber = null, $_BillNarration = null, $_Message = null, $_CustomerReference = null, $_Reference1 = null, $_Reference2 = null, $_newtorkID = null, $_Username = null, $_Password = null)
    {
        $this
            ->set_Billto($_Billto)
            ->set_Billamount($_Billamount)
            ->set_MobileNumber($_MobileNumber)
            ->set_BillNarration($_BillNarration)
            ->set_Message($_Message)
            ->set_CustomerReference($_CustomerReference)
            ->set_Reference1($_Reference1)
            ->set_Reference2($_Reference2)
            ->set_newtorkID($_newtorkID)
            ->set_Username($_Username)
            ->set_Password($_Password);
    }
    /**
     * Get _Billto value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function get_Billto()
    {
        return isset($this->_Billto) ? $this->_Billto : null;
    }
    /**
     * Set _Billto value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $_Billto
     * @return \NetPayment\StructType\RequestMoney
     */
    public function set_Billto($_Billto = null)
    {
        // validation for constraint: string
        if (!is_null($_Billto) && !is_string($_Billto)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($_Billto)), __LINE__);
        }
        if (is_null($_Billto) || (is_array($_Billto) && empty($_Billto))) {
            unset($this->_Billto);
        } else {
            $this->_Billto = $_Billto;
        }
        return $this;
    }
    /**
     * Get _Billamount value
     * @return float|null
     */
    public function get_Billamount()
    {
        return $this->_Billamount;
    }
    /**
     * Set _Billamount value
     * @param float $_Billamount
     * @return \NetPayment\StructType\RequestMoney
     */
    public function set_Billamount($_Billamount = null)
    {
        $this->_Billamount = $_Billamount;
        return $this;
    }
    /**
     * Get _MobileNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function get_MobileNumber()
    {
        return isset($this->_MobileNumber) ? $this->_MobileNumber : null;
    }
    /**
     * Set _MobileNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $_MobileNumber
     * @return \NetPayment\StructType\RequestMoney
     */
    public function set_MobileNumber($_MobileNumber = null)
    {
        // validation for constraint: string
        if (!is_null($_MobileNumber) && !is_string($_MobileNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($_MobileNumber)), __LINE__);
        }
        if (is_null($_MobileNumber) || (is_array($_MobileNumber) && empty($_MobileNumber))) {
            unset($this->_MobileNumber);
        } else {
            $this->_MobileNumber = $_MobileNumber;
        }
        return $this;
    }
    /**
     * Get _BillNarration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function get_BillNarration()
    {
        return isset($this->_BillNarration) ? $this->_BillNarration : null;
    }
    /**
     * Set _BillNarration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $_BillNarration
     * @return \NetPayment\StructType\RequestMoney
     */
    public function set_BillNarration($_BillNarration = null)
    {
        // validation for constraint: string
        if (!is_null($_BillNarration) && !is_string($_BillNarration)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($_BillNarration)), __LINE__);
        }
        if (is_null($_BillNarration) || (is_array($_BillNarration) && empty($_BillNarration))) {
            unset($this->_BillNarration);
        } else {
            $this->_BillNarration = $_BillNarration;
        }
        return $this;
    }
    /**
     * Get _Message value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function get_Message()
    {
        return isset($this->_Message) ? $this->_Message : null;
    }
    /**
     * Set _Message value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $_Message
     * @return \NetPayment\StructType\RequestMoney
     */
    public function set_Message($_Message = null)
    {
        // validation for constraint: string
        if (!is_null($_Message) && !is_string($_Message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($_Message)), __LINE__);
        }
        if (is_null($_Message) || (is_array($_Message) && empty($_Message))) {
            unset($this->_Message);
        } else {
            $this->_Message = $_Message;
        }
        return $this;
    }
    /**
     * Get _CustomerReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function get_CustomerReference()
    {
        return isset($this->_CustomerReference) ? $this->_CustomerReference : null;
    }
    /**
     * Set _CustomerReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $_CustomerReference
     * @return \NetPayment\StructType\RequestMoney
     */
    public function set_CustomerReference($_CustomerReference = null)
    {
        // validation for constraint: string
        if (!is_null($_CustomerReference) && !is_string($_CustomerReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($_CustomerReference)), __LINE__);
        }
        if (is_null($_CustomerReference) || (is_array($_CustomerReference) && empty($_CustomerReference))) {
            unset($this->_CustomerReference);
        } else {
            $this->_CustomerReference = $_CustomerReference;
        }
        return $this;
    }
    /**
     * Get _Reference1 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function get_Reference1()
    {
        return isset($this->_Reference1) ? $this->_Reference1 : null;
    }
    /**
     * Set _Reference1 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $_Reference1
     * @return \NetPayment\StructType\RequestMoney
     */
    public function set_Reference1($_Reference1 = null)
    {
        // validation for constraint: string
        if (!is_null($_Reference1) && !is_string($_Reference1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($_Reference1)), __LINE__);
        }
        if (is_null($_Reference1) || (is_array($_Reference1) && empty($_Reference1))) {
            unset($this->_Reference1);
        } else {
            $this->_Reference1 = $_Reference1;
        }
        return $this;
    }
    /**
     * Get _Reference2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function get_Reference2()
    {
        return isset($this->_Reference2) ? $this->_Reference2 : null;
    }
    /**
     * Set _Reference2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $_Reference2
     * @return \NetPayment\StructType\RequestMoney
     */
    public function set_Reference2($_Reference2 = null)
    {
        // validation for constraint: string
        if (!is_null($_Reference2) && !is_string($_Reference2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($_Reference2)), __LINE__);
        }
        if (is_null($_Reference2) || (is_array($_Reference2) && empty($_Reference2))) {
            unset($this->_Reference2);
        } else {
            $this->_Reference2 = $_Reference2;
        }
        return $this;
    }
    /**
     * Get _newtorkID value
     * @return int|null
     */
    public function get_newtorkID()
    {
        return $this->_newtorkID;
    }
    /**
     * Set _newtorkID value
     * @param int $_newtorkID
     * @return \NetPayment\StructType\RequestMoney
     */
    public function set_newtorkID($_newtorkID = null)
    {
        // validation for constraint: int
        if (!is_null($_newtorkID) && !is_numeric($_newtorkID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($_newtorkID)), __LINE__);
        }
        $this->_newtorkID = $_newtorkID;
        return $this;
    }
    /**
     * Get _Username value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function get_Username()
    {
        return isset($this->_Username) ? $this->_Username : null;
    }
    /**
     * Set _Username value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $_Username
     * @return \NetPayment\StructType\RequestMoney
     */
    public function set_Username($_Username = null)
    {
        // validation for constraint: string
        if (!is_null($_Username) && !is_string($_Username)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($_Username)), __LINE__);
        }
        if (is_null($_Username) || (is_array($_Username) && empty($_Username))) {
            unset($this->_Username);
        } else {
            $this->_Username = $_Username;
        }
        return $this;
    }
    /**
     * Get _Password value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function get_Password()
    {
        return isset($this->_Password) ? $this->_Password : null;
    }
    /**
     * Set _Password value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $_Password
     * @return \NetPayment\StructType\RequestMoney
     */
    public function set_Password($_Password = null)
    {
        // validation for constraint: string
        if (!is_null($_Password) && !is_string($_Password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($_Password)), __LINE__);
        }
        if (is_null($_Password) || (is_array($_Password) && empty($_Password))) {
            unset($this->_Password);
        } else {
            $this->_Password = $_Password;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \NetPayment\StructType\RequestMoney
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
