<?php

namespace NetPayment\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SendMoneyResponse StructType
 * @subpackage Structs
 */
class SendMoneyResponse extends AbstractStructBase
{
    /**
     * The SendMoneyResult
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \NetPayment\StructType\GeneralResponse
     */
    public $SendMoneyResult;
    /**
     * Constructor method for SendMoneyResponse
     * @uses SendMoneyResponse::setSendMoneyResult()
     * @param \NetPayment\StructType\GeneralResponse $sendMoneyResult
     */
    public function __construct(\NetPayment\StructType\GeneralResponse $sendMoneyResult = null)
    {
        $this
            ->setSendMoneyResult($sendMoneyResult);
    }
    /**
     * Get SendMoneyResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \NetPayment\StructType\GeneralResponse|null
     */
    public function getSendMoneyResult()
    {
        return isset($this->SendMoneyResult) ? $this->SendMoneyResult : null;
    }
    /**
     * Set SendMoneyResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \NetPayment\StructType\GeneralResponse $sendMoneyResult
     * @return \NetPayment\StructType\SendMoneyResponse
     */
    public function setSendMoneyResult(\NetPayment\StructType\GeneralResponse $sendMoneyResult = null)
    {
        if (is_null($sendMoneyResult) || (is_array($sendMoneyResult) && empty($sendMoneyResult))) {
            unset($this->SendMoneyResult);
        } else {
            $this->SendMoneyResult = $sendMoneyResult;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \NetPayment\StructType\SendMoneyResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
