<?php

namespace NetPayment\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SendSMSResponse StructType
 * @subpackage Structs
 */
class SendSMSResponse extends AbstractStructBase
{
    /**
     * The SendSMSResult
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \NetPayment\StructType\GeneralResponse
     */
    public $SendSMSResult;
    /**
     * Constructor method for SendSMSResponse
     * @uses SendSMSResponse::setSendSMSResult()
     * @param \NetPayment\StructType\GeneralResponse $sendSMSResult
     */
    public function __construct(\NetPayment\StructType\GeneralResponse $sendSMSResult = null)
    {
        $this
            ->setSendSMSResult($sendSMSResult);
    }
    /**
     * Get SendSMSResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \NetPayment\StructType\GeneralResponse|null
     */
    public function getSendSMSResult()
    {
        return isset($this->SendSMSResult) ? $this->SendSMSResult : null;
    }
    /**
     * Set SendSMSResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \NetPayment\StructType\GeneralResponse $sendSMSResult
     * @return \NetPayment\StructType\SendSMSResponse
     */
    public function setSendSMSResult(\NetPayment\StructType\GeneralResponse $sendSMSResult = null)
    {
        if (is_null($sendSMSResult) || (is_array($sendSMSResult) && empty($sendSMSResult))) {
            unset($this->SendSMSResult);
        } else {
            $this->SendSMSResult = $sendSMSResult;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \NetPayment\StructType\SendSMSResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
